<?php

    // >> <WebMan> - debug
    // Отключаем отладку, если запрос к системе идёт мимо index.php
    if (!defined("DEBUG_ON")) define("DEBUG_ON", 0);
    // << </WebMan> - debug

  // Определяем корень
    define('PATH', dirname(__FILE__));
	define('ROOT', $_SERVER['DOCUMENT_ROOT']);

    // Устанавливаем кодировку
    mb_internal_encoding('UTF-8');

	// Подключаем автозагрузчик классов
	require_once PATH . '/system/config/autoload.php';

    // Устанавливаем обработчик автозагрузки классов
    spl_autoload_register('autoLoadCoreClass');

    cmsCore::startTimer();

	// Инициализируем конфиг
	$config = cmsConfig::getInstance();

    // Проверяем, что система установлена
    if (!$config->isReady()){
        $root = str_replace(str_replace(DIRECTORY_SEPARATOR, '/', realpath(ROOT)), '', str_replace(DIRECTORY_SEPARATOR, '/', PATH));
        header('location:'.$root.'/install/');
        die();
    }

    // Загружаем локализацию
    cmsCore::loadLanguage();

    // Устанавливаем часовую зону
    date_default_timezone_set( $config->time_zone );

    // Подключаем все необходимые классы и библиотеки
	cmsCore::loadLib('html.helper');
	cmsCore::loadLib('strings.helper');
	cmsCore::loadLib('files.helper');
    // >> <WebMan> - optim
	cmsCore::loadLib('spyc.class');
    // << </WebMan> - optim

    // Инициализируем ядро
    $core = cmsCore::getInstance();

    // Подключаем базу
    $core->connectDB();

    if(!$core->db->ready()){
        cmsCore::error(ERR_DATABASE_CONNECT, $core->db->connectError());
    }

    // Запускаем кеш
    // >> <WebMan> - optim
    if ($config->cache_enabled) { cmsCache::getInstance()->start(); }
    // << </WebMan> - optim
